CKEDITOR.dialog.add('semwidgExportDialog', function (editor) {

	var dialog = {};

	dialog.title = 'SemwidgJS Export';
	dialog.minWidth = 800;
	dialog.minHeight = 400;

	dialog.contents = [];

	var exportTab = {};
	exportTab.id = 'exportTab';
	exportTab.label = 'Export';

	exportTab.elements = [
		{
			type: 'html',
			id: 'semwidgckExportTitle',
			html: '<div><h1 id="semwidgckExportTitle">Export Content:</h1></div>'
		},
		{
			type: 'html',
			id: 'semwidgckExportForm',
			html: '<div id="semwidgckExportForm"></div>',
		},
	];

	dialog.contents.push(exportTab);

	dialog.onShow = function() {
		CKEDITOR.SemwidgJS.SemwidgExportDialog.buildExportTab(dialog, editor);
	};

	// dialog.onOk = function() {
	// 	this.semwidgClosingType = 'ok';
	// };

	// dialog.onCancel = function() {
	// 	this.semwidgClosingType = 'cancel';
	// };

	dialog.onHide = function() {

	};

	dialog.onLoad = function() {
		
	};

	dialog.buttons = [CKEDITOR.dialog.okButton];

	return dialog;
});

CKEDITOR.SemwidgJS.SemwidgExportDialog = function() {

};

CKEDITOR.SemwidgJS.SemwidgExportDialog.buildExportTab = function(dialog, editor) {
	var exportForm = $('#semwidgckExportForm');
	var html = '';
	html += '<div style="width: 100%;">';

	html += '<textarea id="semwidgckExportTextarea" readonly rows="16" ';
			html += 'class="cke_dialog_ui_input_textarea" style="font-family: monospace; height: 250px;">';
	
	html += CKEDITOR.SemwidgJS.SemwidgExportDialog.getExportText(editor, false, true, true);

	html += '</textarea>';

	html += '<table><tr>';

	html += '<td style="width: 200px;"><div style="padding-top: 16px;">';
		html += '<div>';
		html += '<input type="radio" name="surroundWithHtml" value="false" checked ';
				html += 'id="semwidgckExportSurroundFalse" />';
		html += '<label for="semwidgckExportSurroundFalse" style="padding-left: 8px;">Plain data</label>';
		html += '</div>';

		html += '<div style="padding-top: 4px; padding-left: 16px;" id="semwidgckExportAddJQueryContainer">';
		html += '<input type="checkbox" name="addJQuery" value="jquery" checked ';
				html += 'id="semwidgckExportAddJQuery" />';
		html += '<label for="semwidgckExportAddJQuery" style="padding-left: 8px;">Add jQuery</label>';
		html += '</div>';

		html += '<div style="padding-left: 16px;" id="semwidgckExportAddSemwidgContainer">';
		html += '<input type="checkbox" name="addSemwidg" value="semwidg" checked ';
				html += 'id="semwidgckExportAddSemwidg" />';
		html += '<label for="semwidgckExportAddSemwidg" style="padding-left: 8px;">Add SemwidgJS</label>';
		html += '</div>';

		html += '<div style="padding-top: 8px;">';
		html += '<input type="radio" name="surroundWithHtml" value="true" ';
				html += 'id="semwidgckExportSurroundTrue" />';
		html += '<label for="semwidgckExportSurroundTrue" style="padding-left: 8px;">HTML document</label>';
		html += '</div>';

		html += '<div style="padding-top: 8px;">';
		html += '<input type="radio" name="surroundWithHtml" value="editor" ';
				html += 'id="semwidgckExportSurroundTruePlusEditor" />';
		html += '<label for="semwidgckExportSurroundTruePlusEditor" style="padding-left: 8px;">HTML document + Editor</label>';
		html += '</div>';
		
	html += '</div></td>';

	html += '<td style="width: 150px;"><div style="padding-top: 16px;">';
		
		html += '<a id="semwidgckExportCreateFileButton" class="cke_dialog_ui_button" ';
				html += 'role="button" hidefocus="true" href="javascript:void(0)" ';
				html += 'style="width: 100%; margin: 4px 0;">';
			html += '<span class="cke_dialog_ui_button">Create File</span>';
		html += '</a>';
		html += '<br>';
		html += '<a id="semwidgckExportDownloadFileButton" class="cke_dialog_ui_button" ';
				html += 'role="button" hidefocus="true" download="export.html" ';
				html += 'style="width: 100%; margin: 4px 0; display: none;>';
			html += '<span class="cke_dialog_ui_button">Download File</span>';
		html += '</a>';
		html += '<br>';
	html += '</div></td>';

	html += '</tr></table>';

	html += '</div>';

	exportForm.html(html);

	var createButton = $('#semwidgckExportCreateFileButton');
	createButton.click(function() {
		
		var link = $('#semwidgckExportDownloadFileButton')[0];
		link.href = CKEDITOR.SemwidgJS.SemwidgExportDialog.createExportFile(
				$('#semwidgckExportTextarea').text());

		$('#semwidgckExportDownloadFileButton').show();
	});

	var updateTextarea = function() {
		var surroundWithHtml = $('#semwidgckExportSurroundTrue').is(':checked');
		var addSemwidgJS = $('#semwidgckExportAddSemwidg').is(':checked');
		var addJQuery = $('#semwidgckExportAddJQuery').is(':checked');
		var surroundWithHtmlPlusEditor = $('#semwidgckExportSurroundTruePlusEditor').is(':checked');

		var data = CKEDITOR.SemwidgJS.SemwidgExportDialog.getExportText(
				editor, surroundWithHtml, addSemwidgJS, addJQuery, surroundWithHtmlPlusEditor);

		$('#semwidgckExportTextarea').text(data);
	}

	$('#semwidgckExportSurroundFalse').change(function() {
		// enable checkboxes
		$('#semwidgckExportAddJQuery').removeAttr('disabled');
		$('#semwidgckExportAddSemwidg').removeAttr('disabled');

		$('#semwidgckExportDownloadFileButton').hide();
		updateTextarea();
	});

	$('#semwidgckExportAddJQuery').change(function() {
		$('#semwidgckExportDownloadFileButton').hide();
		updateTextarea();
	});

	$('#semwidgckExportAddSemwidg').change(function() {
		$('#semwidgckExportDownloadFileButton').hide();
		updateTextarea();
	});

	$('#semwidgckExportSurroundTrue').change(function() {
		// disable checkboxes
		$('#semwidgckExportAddJQuery').attr('disabled', true);
		$('#semwidgckExportAddSemwidg').attr('disabled', true);

		$('#semwidgckExportDownloadFileButton').hide();
		updateTextarea();
	});

	$('#semwidgckExportSurroundTruePlusEditor').change(function() {
		// disable checkboxes
		$('#semwidgckExportAddJQuery').attr('disabled', true);
		$('#semwidgckExportAddSemwidg').attr('disabled', true);

		$('#semwidgckExportDownloadFileButton').hide();
		updateTextarea();
	});
};

CKEDITOR.SemwidgJS.SemwidgExportDialog.textFile = null;
CKEDITOR.SemwidgJS.SemwidgExportDialog.createExportFile = function(text) {
	var data = new Blob([text], {type: 'text/html'});

	if (CKEDITOR.SemwidgJS.SemwidgExportDialog.textFile != null) {
		window.URL.revokeObjectURL(CKEDITOR.SemwidgJS.SemwidgExportDialog.textFile);
	}

	CKEDITOR.SemwidgJS.SemwidgExportDialog.textFile = window.URL.createObjectURL(data);

	return CKEDITOR.SemwidgJS.SemwidgExportDialog.textFile;
};

CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultSemwidgUrl = 'https://semwidg.org/semwidg.js';
CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultJQueryUrl = 'https://code.jquery.com/jquery-2.1.3.min.js';
CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultEditorUrl = 'https://semwidg.org/files/_resources/ckeditor/ckeditor.js';

CKEDITOR.SemwidgJS.SemwidgExportDialog.getExportText = function(editor, surroundWithHtml, addSemwidgJS, addJQuery, surroundWithHtmlPlusEditor) {
	var data = editor.getData();

	var dataObject = $('<div/>').html(data);

	// clear config except for template definitions
	var configs = dataObject.find('[data-sw-config]');
	for (var i = 0; i < configs.length; i++) {
		if ($(configs[i]).attr('data-sw-config').toLowerCase() != 'template') {
			$(configs[i]).empty();
		}
	}

	// clear templates
	dataObject.find('[data-sw-template]').empty();

	// clear widgets
	dataObject.find('[data-sw-widget]').empty();

	data = dataObject.html();

	var html = '';

	if (surroundWithHtml) {

		html += '<!DOCTYPE html>\n';
		html += '<html>\n';
		html += '<head>\n';
		html += '\t<meta charset="utf-8">\n';

		html += '\t<style type="text/css">\n';
		html += '\tbody {\n';
		html += '\t\tcolor: #333;\n';
		html += '\t\tfont-family: sans-serif,Arial,Verdana,"Trebuchet MS";\n';
		html += '\t\tfont-size: 12px;\n';
		html += '\t}\n';

		html += '\ta {\n';
    	html += '\t\tcolor: #0782c1;\n';
		html += '\t}}\n';

		html += '\t</style>\n';

		html += '\t<script src="' + CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultJQueryUrl + '"></script>\n';
		html += '\t<script src="' + CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultSemwidgUrl + '"></script>\n';

		html += '</head>\n';
		html += '<body>\n';

		html += data;

		html += '</body>\n';
		html += '<html>\n';

	}
	else if(surroundWithHtmlPlusEditor) {

		html += '<!DOCTYPE html>\n';
		html += '<html>\n';
		html += '<head>\n';
		html += '\t<meta charset="utf-8">\n';

		html += '\t<style type="text/css">\n';
		html += '\tbody {\n';
		html += '\t\tcolor: #333;\n';
		html += '\t\tfont-family: sans-serif,Arial,Verdana,"Trebuchet MS";\n';
		html += '\t\tfont-size: 12px;\n';
		html += '\t}\n';

		html += '\ta {\n';
    	html += '\t\tcolor: #0782c1;\n';
		html += '\t}}\n';

		html += '\t</style>\n';

		html += '\t<script src="' + CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultJQueryUrl + '"></script>\n';
		html += '\t<script src="' + CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultEditorUrl + '"></script>\n';

		

		html += '</head>\n';
		html += '<body>\n';

		

		html += '<textarea cols="80" id="semwidgCK" name="semwidgCK" rows="10">\n';
		html += data;
		html += '</textarea>\n';

		html += '\t<script type="text/javascript">\n';
		html += '\t\tCKEDITOR.replace("semwidgCK", {\n';
		html += '\t\t\textraPlugins: "widget,lineutils,semwidg",\n';
		html += '\t\t\textraAllowedContent: "*[data-*]",\n';
		html += '\t\t\theight: (window.innerHeight) + "px"\n';
		html += '\t\t});\n';
		html += '\t\n';
		html += '\t\tCKEDITOR.instances["semwidgCK"].on("instanceReady", function(e) {\n';
		html += '\t\t\te.editor.execCommand("maximize");\n';
		html += '\t\t});\n';
		html += '\t</script>\n';

		html += '</body>\n';
		html += '<html>\n';

	} 
	else {

		if (addJQuery) {
			html += '<script src="' + CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultJQueryUrl + '"></script>\n';
		}

		if (addSemwidgJS) {
			html += '<script src="' + CKEDITOR.SemwidgJS.SemwidgExportDialog.defaultSemwidgUrl + '"></script>\n';
		}

		if (addJQuery || addSemwidgJS) {
			html += '\n';
		}

		html += data;

	}

	return html;
};