CKEDITOR.plugins.add( 'semwidg', {
	requires: 'richcombo,widget',
	
	icons: 'semwidgConfigWizard,semwidgExport,semwidg,semwidg2,semwidg3',
	
	init: function(editor) {

		console.log('Clear cache with: CKEDITOR.instances.' + editor.name + '.getSemwidgJS().SparqlCache.getCache().clear();');

		var config = editor.config;
		var lang = editor.lang.format;
		var pluginPath = this.path;
		var version = 'V171129';

		var jQueryPath = pluginPath + 'js/jquery.js';
		var semwidgJsPath = 'https://semwidg.org/semwidg.js';
		var semwidgCssPath = pluginPath + 'styles/styles.css?t=' + version;
		var semwidgToolsCssPath = pluginPath + 'styles/semwidg-tools.css?t=' + version;
		var fontAwesomeCssPath = pluginPath + 'styles/font-awesome.min.css?t=' + version;

		editor.getSemwidgJS = function() {
			return editor.document.$.defaultView.SemwidgJS;
		}

		editor.getSemwidgQL = function() {
			return editor.document.$.defaultView.SemwidgQL;
		}

		// editor.addContentsCss(pluginPath + 'styles/styles.css');

		editor.addCommand('semwidgWidget', new CKEDITOR.dialogCommand('semwidgWidgetDialog'));
		CKEDITOR.dialog.add('semwidgWidgetDialog', pluginPath + 'dialogs/semwidgWidgetDialog.js?t=' + version);

		editor.addCommand('semwidgConfig', new CKEDITOR.dialogCommand('semwidgConfigDialog'));
		CKEDITOR.dialog.add('semwidgConfigDialog', pluginPath + 'dialogs/semwidgConfigDialog.js?t=' + version);

		editor.addCommand('semwidgTemplate', new CKEDITOR.dialogCommand('semwidgTemplateDialog'));
		CKEDITOR.dialog.add('semwidgTemplateDialog', pluginPath + 'dialogs/semwidgTemplateDialog.js?t=' + version);

		editor.addCommand('semwidgTemplateInstance', new CKEDITOR.dialogCommand('semwidgTemplateInstanceDialog'));
		CKEDITOR.dialog.add('semwidgTemplateInstanceDialog', pluginPath + 'dialogs/semwidgTemplateInstanceDialog.js?t=' + version);

		editor.addCommand('semwidgConfigWizard', new CKEDITOR.dialogCommand('semwidgConfigWizardDialog'));
		CKEDITOR.dialog.add('semwidgConfigWizardDialog', pluginPath + 'dialogs/semwidgConfigWizardDialog.js?t=' + version);

		editor.addCommand('semwidgExport', new CKEDITOR.dialogCommand('semwidgExportDialog'));
		CKEDITOR.dialog.add('semwidgExportDialog', pluginPath + 'dialogs/semwidgExportDialog.js?t=' + version);

		editor.addCommand('semwidgSemwidgQL', new CKEDITOR.dialogCommand('semwidgSemwidgQLDialog'));
		CKEDITOR.dialog.add('semwidgSemwidgQLDialog', pluginPath + 'dialogs/semwidgSemwidgQLDialog.js?t=' + version);

		editor.addCommand('semwidgWidgetFromResource', {
			exec: function(editor) {
				CKEDITOR.SemwidgJS.createNewWidgetFromResource(editor);}
		});

		editor.widgets.add('semwidgWidget', {

			dialog: 'semwidgWidgetDialog',

			edit: function() {
				var value = this.element.getAttribute('data-sw-widget');
				if (value) {
					CKEDITOR.SemwidgJS.data.widgetType = 'widget_' + value;
				}
			},

			template: '',

			allowedContent: '*[data-*]',

			requiredContent: '*[data-*]',

			// data: function() {

			// },

			upcast: function(element) {
				if (element.attributes['data-sw-widget']) {
					return true;
				}
			},

			// init: function() {
				// this.on('ready',function(e) {
				// 	console.log('ready', this, e);
				// });
			// }

		});

		editor.widgets.add('semwidgConfig', {

			dialog: 'semwidgConfigDialog',

			edit: function() {

				var value = this.element.getAttribute('data-sw-config');
				if (value && value != 'template') {
					CKEDITOR.SemwidgJS.data.configType = 'config_' + value;
				}
			},

			template: '',

			allowedContent: '*[data-*]',

			requiredContent: '*[data-*]',

			data: function() {

			},

			upcast: function(element) {

				if (element.attributes['data-sw-config'] && element.attributes['data-sw-config'] !== 'template') {

					element.setHtml('<span style="display: none">placeholder</span>');

					return true;
				}
			}

		});

		editor.widgets.add('semwidgTemplate', {

			dialog: 'semwidgTemplateDialog',

			edit: function() {

				var value = this.element.getAttribute('data-sw-config');
				if (value == 'template') {
					CKEDITOR.SemwidgJS.data.configType = 'template_definition';
				}
			},

			template: '',

			allowedContent: '*[data-*]',

			requiredContent: '*[data-*]',

			data: function() {

			},

			upcast: function(element) {
				if (element.attributes['data-sw-config'] == 'template') {
					return true;
				}
			},

			editables: {
				content: {
					selector: '*[data-sw-config="template"]',
					allowedContent: ''
				}
			}

		});

		editor.widgets.add('semwidgTemplateInstance', {

			dialog: 'semwidgTemplateInstanceDialog',

			edit: function() {
				var value = this.element.getAttribute('data-sw-template');
				if (value) {
					CKEDITOR.SemwidgJS.data.templateType = value;
				}
			},

			template: '',

			allowedContent: '*[data-*]',

			requiredContent: '*[data-*]',

			data: function() {

			},

			upcast: function(element) {

				if (element.attributes['data-sw-template']) {
					return true;
				}
			}
		});

		editor.contextMenu.addListener(function(element, selection) {
			var elem = element.$.childNodes[0];

			if (elem.nodeType == 1) {

				var item;

				if (elem.hasAttribute('data-sw-widget')) {

					item = new CKEDITOR.menuItem(editor, 'semwidgWidget', {
						label: 'Edit Widget',
						name: 'editSemwidgWidget',
						command: 'semwidgWidget',
						group: 'others',
						order: -1,
						state: 2
					});
					editor.contextMenu.add(item);

				}else if(elem.hasAttribute('data-sw-config') && elem.getAttribute('data-sw-config').toLowerCase() != 'template') {

					item = new CKEDITOR.menuItem(editor, 'semwidgConfig', {
						label: 'Edit Config',
						name: 'editSemwidgConfig',
						command: 'semwidgConfig',
						group: 'others',
						order: -1,
						state: 2
					});
					editor.contextMenu.add(item);

					if (elem.getAttribute('data-sw-config').toLowerCase() == 'resource') {
						item = new CKEDITOR.menuItem(editor, 'semwidgConfig', {
							label: 'Add Widget based on this Resource',
							name: 'newWidget',
							command: 'semwidgWidgetFromResource',
							group: 'others',
							order: -1,
							state: 2
						});
						editor.contextMenu.add(item);
					}

				}else if(elem.hasAttribute('data-sw-config') && elem.getAttribute('data-sw-config').toLowerCase() == 'template') {

					item = new CKEDITOR.menuItem(editor, 'semwidgTemplate', {
						label: 'Edit Template Definition',
						name: 'editSemwidgTemplate',
						command: 'semwidgTemplate',
						group: 'others',
						order: -1,
						state: 2
					});
					editor.contextMenu.add(item);

				}else if(elem.hasAttribute('data-sw-template')) {

					item = new CKEDITOR.menuItem(editor, 'semwidgTemplateInstance', {
						label: 'Edit Template Instance',
						name: 'editSemwidgTemplateInstance',
						command: 'semwidgTemplateInstance',
						group: 'others',
						order: -1,
						state: 2
					});
					editor.contextMenu.add(item);
				}

			}
			
		});

		editor.on('instanceReady', function(e) {
			// addAndRunSemwidgJS();
			// buildSemwidgTools();
		});

		editor.on('beforeSetMode', function(e) {
			if (editor.mode == 'wysiwyg' && e.data == 'source') {
				try {
					CKEDITOR.SemwidgJS.saveSemwidgToolsState(editor);
					editor.getSemwidgJS().destroy();
				}catch (e) {

				}
			}
		});

		editor.on('mode', function(e) {
			if (editor.mode == 'wysiwyg') {
				addAndRunSemwidgJS();
				// buildSemwidgTools();
			}
		});

		editor.on('paste', function(e) {

			// Remove content of dragged widgets

			var elem = $('<div>' + e.data.dataValue + '</div>');

			var widgets = elem.find('*[data-sw-widget]');
			var configs = elem.find('*[data-sw-config]').not('*[data-sw-config="template"]');
			var templates = elem.find('*[data-sw-template]');

			if (widgets.length + configs.length + templates.length > 0) {

				widgets.html('');
				configs.html('');
				templates.html('');

				// elem.html() is not working, propably because of caching
				e.data.dataTransfer.setData('text/html', elem[0].innerHTML);
				e.data.dataValue = elem[0].innerHTML;

				if (widgets.length > 0){
					CKEDITOR.SemwidgJS.refreshRequired = true;
				}
			}
		});

		editor.on('afterPaste', function(e) {

			if (CKEDITOR.SemwidgJS.refreshRequired) {

				CKEDITOR.SemwidgJS.refresh(editor.id);
				CKEDITOR.SemwidgJS.refreshRequired = false;
			}

		});


		editor.semwidgToolsModel = new CKEDITOR.SemwidgJS.SemwidgToolsModel();
		
		var buildSemwidgTools = function() {

			var i = 0;
			var editorId = editor.id;

			var editorWindow = editor.container.$;
			var innerWindow = $(editorWindow).find('.cke_contents');

			innerWindow.prepend('<div id="' + editor.id + '_semwidgTools"></div>');

			var tools = innerWindow.find('#' + editor.id + '_semwidgTools');
			tools.addClass('semwidgTools');
			tools.css('border-right', '1px solid #979797');
			tools.css('background-color', '#e4e4e4');
			tools.css('width', '250px');
			tools.css('height', '100%');
			tools.css('overflow', 'auto');
			tools.css('float', 'left');

			var iframe = innerWindow.find('.cke_wysiwyg_frame');
			iframe.css('width', 'calc(100% - 251px)');

			tools.append('<h1 class="title">SemwidgJS Toolbox</h1>');
			var toolboxHtml = '<div class="semwidgToolbox">';

			toolboxHtml += '<span class="cke_toolgroup"><a onClick="CKEDITOR.SemwidgJS.execCommand(\'' + editorId + '\', \'semwidgConfigWizard\')" ' + 
					'class="cke_button cke_format cke_button_off" title="SemwidgJS Config Wizard" ' + 
					'style="width: 99px;">' +
					'<span style="background-image:url(' + pluginPath + '/icons/semwidgConfigWizard.png?t=' + version + ');background-position:0 0px;background-size:16px;" class="cke_button_icon cke_button__semwidgConfigWizard_icon">&nbsp;</span>' +
					'<span class="cke_button_label">Config Wizard</span>' + 
					'</a></span>';

			toolboxHtml += '<span class="cke_toolgroup"><a onClick="CKEDITOR.SemwidgJS.refresh(\'' + editorId + '\')" ' + 
					'class="cke_button cke_format cke_button_off" title="Apply \& Refresh"' + 
					'style="width: 68px;">' +
					'<span style="background-image:url(' + pluginPath + '/icons/semwidgRefresh.png?t=' + version + ');background-position:0 0px;background-size:16px;" class="cke_button_icon cke_button__semwidgConfigWizard_icon">&nbsp;</span>' +
					'<span class="cke_button_label">Refresh</span>' + 
					'</a></span>';

			toolboxHtml += '<span class="cke_toolgroup"><a onClick="CKEDITOR.SemwidgJS.createTemplate(\'' + editorId + '\')" ' + 
					'class="cke_button cke_format cke_button_off" title="Create Template from Selection"' + 
					'style="width: 112px;">' +
					'<span style="background-image:url(' + pluginPath + '/icons/semwidgTemplate.png?t=' + version + ');background-position:0 0px;background-size:16px;" class="cke_button_icon cke_button__semwidgConfigWizard_icon">&nbsp;</span>' +
					'<span class="cke_button_label">Create Template</span>' + 
					'</a></span>';

			toolboxHtml += '<span class="cke_toolgroup"><a onClick="CKEDITOR.SemwidgJS.execCommand(\'' + editorId + '\', \'semwidgExport\')" ' + 
					'class="cke_button cke_format cke_button_off" title="Export HTML"' + 
					'style="width: 55px;">' +
					'<span style="background-image:url(' + pluginPath + '/icons/semwidgExport.png?t=' + version + ');background-position:0 0px;background-size:16px;" class="cke_button_icon cke_button__semwidgConfigWizard_icon">&nbsp;</span>' +
					'<span class="cke_button_label">Export</span>' + 
					'</a></span>';

			toolboxHtml += '</div>';

			tools.append(toolboxHtml);

			tools.append('<h2 class="title">Widget Management</h2>');

			var addConfigHtml = '<div class="semwidgToolbox">Add: ' +
					'<select onclick="CKEDITOR.SemwidgJS.addSemwidgElement(\'Config\', this.value, \'' + editorId + '\'); this.selectedIndex = 0;" ' + 
							'class="semwidg_input_select">' + 
						'<option value="">— Config Element —</option>' +
						'<option value="Endpoint">Endpoint</option>' +
						'<option value="Resource">Resource</option>' +
						'<option value="Namespace">Namespace</option>' +
						'<option value="Mapping">Mapping</option>' +
						'<option value="Proxy">Proxy</option>' +
					'</select>' + 
					'</div>';

			tools.append(addConfigHtml);

			var configElements = editor.getSemwidgJS().getConfig();

			var endpoints = configElements.getEndpoints();
			var resources = configElements.getResources();
			var namespaces = configElements.getNamespaces();
			var mappings = configElements.getMappings();
			var proxies = configElements.getProxies();

			var endpointsHtml = '<ul><li>Endpoints <a ' +
					'class="semwidgToolsEndpointAdd" ' +
					'onClick="CKEDITOR.SemwidgJS.addSemwidgElement(\'Config\', \'Endpoint\', \'' + editorId + '\');" ' +
					'title="Create New Endpoint">' + 
					'<i class="fa fa-plus"></i></a><ul>';
			for (i = 0; i < endpoints.length; i++) {
				endpointsHtml += '<li><a ' +
						'class="semwidgToolsEndpointEdit" ' +
						'onClick="CKEDITOR.SemwidgJS.editSemwidgElement(\'Config\', \'Endpoint\', \'' + endpoints[i].getId() + '\', \'' + editorId + '\');" ' +
						'title="Edit Endpoint">' + 
						endpoints[i].getId() + '</a> ' +
						'<a class="semwidgToolsEndpointDelete" ' +
						'onClick="CKEDITOR.SemwidgJS.deleteSemwidgElement(\'Config\', \'Endpoint\', \'' + endpoints[i].getId() + '\', \'' + editorId + '\');"' +
						'title="Delete Endpoint"><i class="fa fa-trash-o"></i></a></li>';
			}

			endpointsHtml += '</ul></li></ul>';

			var resourcesHtml = '<ul><li>Resources <a ' +
					'class="semwidgToolsResourceAdd" ' +
					'onClick="CKEDITOR.SemwidgJS.addSemwidgElement(\'Config\', \'Resource\', \'' + editorId + '\');" ' +
					'title="Create New Resource">' + 
					'<i class="fa fa-plus"></i></a><ul>';
			for (i = 0; i < resources.length; i++) {
				resourcesHtml += '<li><a ' +
						'class="semwidgToolsResourceEdit" ' +
						'onClick="CKEDITOR.SemwidgJS.editSemwidgElement(\'Config\', \'Resource\', \'' + resources[i].getId() + '\', \'' + editorId + '\');" ' +
						'title="Edit Resource">' + 
						resources[i].getId() + '</a> ' +
						'<a class="semwidgToolsresourceDelete" ' +
						'onClick="CKEDITOR.SemwidgJS.deleteSemwidgElement(\'Config\', \'Resource\', \'' + resources[i].getId() + '\', \'' + editorId + '\');"' +
						'title="Delete Resource"><i class="fa fa-trash-o"></i></a></li>';
			}
			resourcesHtml += '</ul></li></ul>';

			var namespacesHtml = '<ul><li>Namespaces <a ' +
					'class="semwidgToolsNamespaceAdd" ' +
					'onClick="CKEDITOR.SemwidgJS.addSemwidgElement(\'Config\', \'Namespace\', \'' + editorId + '\');" ' +
					'title="Create New Namespace">' + 
					'<i class="fa fa-plus"></i></a><ul>';
			for (i = 0; i < namespaces.length; i++) {
				if (namespaces[i]._getNode()) {
					namespacesHtml += '<li><a ' +
							'class="semwidgToolsNamespaceEdit" ' +
							'onClick="CKEDITOR.SemwidgJS.editSemwidgElement(\'Config\', \'Namespace\', \'' + namespaces[i].getId() + '\', \'' + editorId + '\');" ' +
							'title="Edit Namespace">' + 
							namespaces[i].getId() + '</a> ' +
							'<a class="semwidgToolsNamespaceDelete" ' +
							'onClick="CKEDITOR.SemwidgJS.deleteSemwidgElement(\'Config\', \'Namespace\', \'' + namespaces[i].getId() + '\', \'' + editorId + '\');"' +
							'title="Delete Namespace"><i class="fa fa-trash-o"></i></a></li>';
				}
			}
			namespacesHtml += '</ul></li></ul>';

			var mappingsHtml = '<ul><li>Mappings <a ' +
					'class="semwidgToolsMappingAdd" ' +
					'onClick="CKEDITOR.SemwidgJS.addSemwidgElement(\'Config\', \'Mapping\', \'' + editorId + '\');" ' +
					'title="Create New Mapping">' + 
					'<i class="fa fa-plus"></i></a><ul>';
			for (i = 0; i < mappings.length; i++) {
				mappingsHtml += '<li><a ' +
						'class="semwidgToolsMappingEdit" ' +
						'onClick="CKEDITOR.SemwidgJS.editSemwidgElement(\'Config\', \'Mapping\', \'' + mappings[i].getId() + '\', \'' + editorId + '\');" ' +
						'title="Edit Mapping">' + 
						mappings[i].getId() + '</a> ' +
						'<a class="semwidgToolsMappingDelete" ' +
						'onClick="CKEDITOR.SemwidgJS.deleteSemwidgElement(\'Config\', \'Mapping\', \'' + mappings[i].getId() + '\', \'' + editorId + '\');"' +
						'title="Delete Mapping"><i class="fa fa-trash-o"></i></a></li>';
			}
			mappingsHtml += '</ul></li></ul>';

			var proxiesHtml = '<ul><li>Proxies <a ' +
					'class="semwidgToolsProxyAdd" ' +
					'onClick="CKEDITOR.SemwidgJS.addSemwidgElement(\'Config\', \'Proxy\', \'' + editorId + '\');" ' +
					'title="Create New Proxy">' + 
					'<i class="fa fa-plus"></i></a><ul>';
			for (i = 0; i < proxies.length; i++) {
				proxiesHtml += '<li><a ' +
						'class="semwidgToolsProxyEdit" ' +
						'onClick="CKEDITOR.SemwidgJS.editSemwidgElement(\'Config\', \'Proxy\', \'' + proxies[i].getId() + '\', \'' + editorId + '\');" ' +
						'title="Edit Proxy">' + 
						proxies[i].getId() + '</a> ' +
						'<a class="semwidgToolsProxyDelete" ' +
						'onClick="CKEDITOR.SemwidgJS.deleteSemwidgElement(\'Config\', \'Proxy\', \'' + proxies[i].getId() + '\', \'' + editorId + '\');"' +
						'title="Delete Proxy"><i class="fa fa-trash-o"></i></a></li>';
			}
			proxiesHtml += '</ul></li></ul>';


			var configHtml = '<ul id="' + editor.id + '_semwidgTools_collapsibleListConfig" class="semwidgCollapsibleList">';
			configHtml += '<li>Config';
			configHtml += endpointsHtml;
			configHtml += resourcesHtml;
			configHtml += namespacesHtml;
			configHtml += mappingsHtml;
			configHtml += proxiesHtml;

			configHtml += '</li></ul>';

			tools.append(configHtml);

			var allWidgetTypes = editor.getSemwidgJS().WidgetProvider.getWidgetTypes();

			var addWidgetHtml = '<div class="semwidgToolbox">Add: ' +
					'<select onclick="CKEDITOR.SemwidgJS.addSemwidgElement(\'Widget\', this.value, \'' + editorId + '\'); this.selectedIndex = 0;" ' + 
							'class="semwidg_input_select">' + 
						'<option value="">— Widget —</option>';

			for (var type in allWidgetTypes) {
				if (type && type != 'SwWidget') {
					addWidgetHtml += '<option value="' + type + '">' + type + '</option>';
				}
			}

			addWidgetHtml += '</select></div>';

			tools.append(addWidgetHtml);

			var widgets = editor.getSemwidgJS().getWidgetProvider().getWidgets();
			var widgetTypesObj = {};
			for (i = 0; i < widgets.length; i++) {
				if (!widgetTypesObj[widgets[i]._getType()]) {
					widgetTypesObj[widgets[i]._getType()] = [];
				}
				widgetTypesObj[widgets[i]._getType()].push(widgets[i]);
			}
			var widgetTypes = Object.keys(widgetTypesObj);
			widgetTypes.sort();

			var widgetsHtml = '<ul id="' + editor.id + '_semwidgTools_collapsibleListWidgets" class="semwidgCollapsibleList">';
			widgetsHtml += '<li>Widgets';
			for (i = 0; i < widgetTypes.length; i++) {
				widgetsHtml += '<ul><li>' + widgetTypes[i] + '<ul>';

				var widgetsByType = widgetTypesObj[widgetTypes[i]];
				for (var j = 0; j < widgetsByType.length; j++) {
					widgetsHtml += '<li><a ' +
							'class="semwidgToolsWidgetEdit" ' +
							'onClick="CKEDITOR.SemwidgJS.editSemwidgElement(\'Widget\', \'' + widgetTypes[i] + '\', \'' + widgetsByType[j].getId() + '\', \'' + editorId + '\');"' +
							'title="Edit Widget">' + 
							widgetsByType[j].getId() + '</a> ' +
							'<a class="semwidgToolsWidgetDelete" ' +
							'onClick="CKEDITOR.SemwidgJS.deleteSemwidgElement(\'Widget\', \'' + widgetTypes[i] + '\', \'' + widgetsByType[j].getId() + '\', \'' + editorId + '\');"' +
							'title="Delete Widget"><i class="fa fa-trash-o"></i></a></li>';
				}

				widgetsHtml += '</ul></li></ul>'
			}

			widgetsHtml += '</li></ul>';

			tools.append(widgetsHtml);

			var templateDefinitions = editor.getSemwidgJS().getTemplateProvider().getTemplateDefinitions()
			var addTemplateHtml = '<div class="semwidgToolbox">Add: ' +
					'<select onclick="CKEDITOR.SemwidgJS.addSemwidgElement(\'Template\', this.value, \'' + editorId + '\'); this.selectedIndex = 0;" ' + 
							'class="semwidg_input_select">' + 
						'<option value="">— Template Instance —</option>';

			for (i = 0; i < templateDefinitions.length; i++) {
				addTemplateHtml += '<option value="' + templateDefinitions[i].getId() + '">' + templateDefinitions[i].getId() + '</option>';
			}

			addTemplateHtml += '</select></div>';

			tools.append(addTemplateHtml);

			var templateDefinitions = editor.getSemwidgJS().getTemplateProvider().getTemplateDefinitions();
			var templateDefinitionsHtml = '<ul><li>Definitions<ul>';
			for (i = 0; i < templateDefinitions.length; i++) {
				templateDefinitionsHtml += '<li><a ' +
						'class="semwidgToolsTemplateDefinitionEdit" ' +
						'onClick="CKEDITOR.SemwidgJS.editSemwidgElement(\'TemplateDefinition\', \'TemplateDefinition\', \'' + templateDefinitions[i].getId() + '\', \'' + editorId + '\');" ' +
						'title="Edit Template Definition">' + 
						templateDefinitions[i].getId() + '</a> ' +
						'<a class="semwidgToolsTemplateDefinitionDelete" ' +
						'onClick="CKEDITOR.SemwidgJS.deleteSemwidgElement(\'TemplateDefinition\', \'TemplateDefinition\', \'' + templateDefinitions[i].getId() + '\', \'' + editorId + '\');"' +
						'title="Delete Template Definition"><i class="fa fa-trash-o"></i></a></li>';
			}
			templateDefinitionsHtml += '</ul></li></ul>';

			var templates = editor.getSemwidgJS().getTemplateProvider().getTemplates();
			var templatesHtml = '<ul><li>Instances<ul>';
			for (i = 0; i < templates.length; i++) {
				templatesHtml += '<li><a ' +
						'class="semwidgToolsTemplateInstanceEdit" ' +
						'onClick="CKEDITOR.SemwidgJS.editSemwidgElement(\'Template\', \'' + templates[i]._getType() + '\', \'' + templates[i].getId() + '\', \'' + editorId + '\');" ' +
						'title="Edit Template Instance">' + 
						templates[i].getId() + '</a> ' +
						'<a class="semwidgToolsTemplateInstanceDelete" ' +
						'onClick="CKEDITOR.SemwidgJS.deleteSemwidgElement(\'Template\', \'' + templates[i]._getType() + '\', \'' + templates[i].getId() + '\', \'' + editorId + '\');"' +
						'title="Delete Template Instance"><i class="fa fa-trash-o"></i></a></li>';
			}
			templatesHtml += '</ul></li></ul>';

			var templateHtml = '<ul id="' + editor.id + '_semwidgTools_collapsibleListTemplates" class="semwidgCollapsibleList">';
			templateHtml += '<li>Templates';
			templateHtml += templateDefinitionsHtml;
			templateHtml += templatesHtml;
			templateHtml += '</li></ul>';

			tools.append(templateHtml);

			var semwidgCollapsibleLists = document.getElementById(editor.id + '_semwidgTools').getElementsByClassName('semwidgCollapsibleList');
			for (i=0; i < semwidgCollapsibleLists.length; i++) {
				CKEDITOR.SemwidgJS.activateTree(semwidgCollapsibleLists[i]);
			}
			
			tools.append('<h2 class="title">Display Settings</h2>');

			var toggleWidgetHighlightHtml = '<div class="switch-area">' +
					'<div class="switch-title">Highlight Widgets</div>' + 
						'<label class="switch switch-green">' + 
							'<input id="' + editor.id + '_semwidgTools_toggleWidgetHighlight" ' + 
							'type="checkbox" class="switch-input" checked ' + 
							'onchange="CKEDITOR.SemwidgJS.toggleHighlightWidgets(this, \'' + editorId + '\');" >' + 
							'<span class="switch-label" data-on="On" data-off="Off"></span>' + 
							'<span class="switch-handle"></span>' +
						'</label>' + 
					'</div>';

			tools.append(toggleWidgetHighlightHtml);

			var toggleConfigVisibilityHtml = '<div class="switch-area">' +
					'<div class="switch-title">Show Config-Widgets</div>' + 
						'<label class="switch switch-green">' + 
							'<input id="' + editor.id + '_semwidgTools_toggleConfigVisibility" ' + 
							'type="checkbox" class="switch-input" checked ' + 
							'onchange="CKEDITOR.SemwidgJS.toggleConfigVisibility(this, \'' + editorId + '\');" >' + 
							'<span class="switch-label" data-on="On" data-off="Off"></span>' + 
							'<span class="switch-handle"></span>' +
						'</label>' + 
					'</div>';

			tools.append(toggleConfigVisibilityHtml);

			var toggleTemplateDefinitionVisibilityHtml = '<div class="switch-area">' +
					'<div class="switch-title">Show Template Definitions</div>' + 
						'<label class="switch switch-green">' + 
							'<input id="' + editor.id + '_semwidgTools_toggleTemplateDefinitionVisibility" ' + 
							'type="checkbox" class="switch-input" checked ' + 
							'onchange="CKEDITOR.SemwidgJS.toggleTemplateDefinitionVisibility(this, \'' + editorId + '\');" >' + 
							'<span class="switch-label" data-on="On" data-off="Off"></span>' + 
							'<span class="switch-handle"></span>' +
						'</label>' + 
					'</div>';

			tools.append(toggleTemplateDefinitionVisibilityHtml);

			// -- CSS files
			CKEDITOR.SemwidgJS.addCSS(null, fontAwesomeCssPath, '_FontAwesome_', null);
			CKEDITOR.SemwidgJS.addCSS(null, semwidgToolsCssPath, '_SemwidgTools_', null);


			CKEDITOR.SemwidgJS.recreateSemwidgToolsState(editor);
		};

		var addAndRunSemwidgJS = function() {

			CKEDITOR.SemwidgJS.addCSS(editor, semwidgCssPath, '_SemwidgStyles_', null);

			/*
			 * 1. add jQuery
			 * 2. add SemwidgJS
			 * 3. run SemwidgJS
			 * 4. build SemwidgTools Sidebar
			 * 5. run functions in queue
			 * 6. set cursor position
			 */
			var runSemwidgJS = function() {
				/* 3. */ editor.getSemwidgJS().run();
				/* 4. */ buildSemwidgTools();

				/* 5. */
				for (var f = 0; f < CKEDITOR.SemwidgJS.runAfterSemwidgIsLoaded.length; f++) {
					CKEDITOR.SemwidgJS.runAfterSemwidgIsLoaded[f]();
				}
				CKEDITOR.SemwidgJS.runAfterSemwidgIsLoaded.length = 0;

				/* 6. */
				if (CKEDITOR.SemwidgJS.newElementIds.length > 0) {
					CKEDITOR.SemwidgJS.setPosition(editor);
				}
			};
			var addSemwidgJS = function() {
				/* 2. */ CKEDITOR.SemwidgJS.addJS(editor, semwidgJsPath, '_SemwidgJS_', runSemwidgJS);
			}
			/* 1. */ CKEDITOR.SemwidgJS.addJS(editor, jQueryPath, '_jQuery_', addSemwidgJS);
			
		};
	}
});

if (!CKEDITOR.SemwidgJS) {
	CKEDITOR.SemwidgJS = function() {};
	CKEDITOR.SemwidgJS.data = {};
	CKEDITOR.SemwidgJS.runAfterSemwidgIsLoaded = [];
	CKEDITOR.SemwidgJS.refreshRequired = false;
	CKEDITOR.SemwidgJS.newElementIds = [];
}

CKEDITOR.SemwidgJS.getTemplateForWidget = function(type, editor, data) {
	
	var widgetProperties = CKEDITOR.SemwidgJS.getWidgetProperties(type, editor);
	var basicProperties = CKEDITOR.SemwidgJS.getBasicWidgetProperties(editor);

	var html = '';

	html += '<div data-sw-widget="' + type + '" ';

	var propertyName;
	var value = '';
	for (var i = 0; i < basicProperties.length; i++) {
		propertyName = editor.getSemwidgJS().Util.String.toCamelCase(basicProperties[i]);

		if (data && data.hasOwnProperty(propertyName)) {
			value = data[propertyName];
		}else {
			value = '';
		}

		html += 'data-swp-' + propertyName + '="' + value + '" ' ;
	}

	for (var i = 0; i < widgetProperties.length; i++) {
		propertyName = editor.getSemwidgJS().Util.String.toCamelCase(widgetProperties[i]);

		if (data && data.hasOwnProperty(propertyName)) {
			value = data[propertyName];
		}else {
			value = '';
		}

		html += 'data-swp-' + propertyName + '="' + value + '" ' ;
	}

	html += '></div>';

	return html;
};

CKEDITOR.SemwidgJS.getBasicWidgetProperties = function(editor) {
	if (!this.basicWidgetProperties) {

		var widget = new (editor.getSemwidgJS()).SwWidget();
		
		this.basicWidgetProperties = [];

		// id is first property
		this.basicWidgetProperties.push('Id');

		for (var property in widget._getProperties()) {

			// Don't push 'Value'. This property should appear on the widget property tab.
			if (property != 'Id' && property != 'Value') {
				this.basicWidgetProperties.push(property);
			}
		}
	}
	return this.basicWidgetProperties;
};

CKEDITOR.SemwidgJS.getWidgetProperties = function(type, editor) {

	var basicProperties = CKEDITOR.SemwidgJS.getBasicWidgetProperties(editor);
	var allProperties = editor.getSemwidgJS().WidgetProvider.getWidgetTypes()[type].prototype.properties;

	var widgetProperties = [];
	for (var property in allProperties) {
		var toAdd = true;
		for (var j = 0; j < basicProperties.length; j++) {
			if (property == basicProperties[j]) {
				toAdd = false;
				break;
			}
		}
		if (toAdd) {
			widgetProperties.push(property);
		}
	}
	return widgetProperties;
};

CKEDITOR.SemwidgJS.getProperty = function(widgetType, propertyName, editor) {

	try {
		return editor.getSemwidgJS().WidgetProvider.getWidgetTypes()[widgetType].prototype.properties[propertyName];
	}catch (error) {

	}

	return null;
};

CKEDITOR.SemwidgJS.getTemplateForConfig = function(type, editor, data) {

	var html = '';
	var type = type.toLowerCase();

	html += '<div data-sw-config="' + editor.getSemwidgJS().Util.String.toCamelCase(type) + '" ';

	var attributes = CKEDITOR.SemwidgJS.getConfigProperties(type);

	for (var i = 0; i < attributes.length; i++) {
		if (data && data.hasOwnProperty(attributes[i])) {
			value = data[attributes[i]];
		}else {
			value = '';
		}

		html += 'data-swp-' + attributes[i] + '="' + value + '" ' ;
	}

	html += '></div>';

	return html;
};


CKEDITOR.SemwidgJS.getConfigProperties = function(type) {

	type = ('' + type).toLowerCase();

	var attributes;
	switch (type) {
		case 'endpoint':
			attributes = ['id', 'url', 'default-graph-uri', 'default-lang', 'proxy', 'default', 'http-method'];
			break;
		case 'resource':
			attributes = ['id', 'uri', 'endpoint'];
			break;
		case 'namespace':
			attributes = ['id', 'uri'];
			break;
		case 'mapping':
			attributes = ['id', 'value'];
			break;
		case 'proxy':
			attributes = ['id', 'url'];
			break;
		default:
			attributes = [];
			break;
	}
	return attributes;
};

CKEDITOR.SemwidgJS.getTemplateForTemplate = function(type, editor, data) {

	var html = '';

	html += '<div data-sw-template="' + type + '" ';
	html += 'data-swp-id="TemplateInstance-' + editor.getSemwidgJS().Util.getUniqueId() + '" ';
	html += '></div>';

	return html;
};

CKEDITOR.SemwidgJS.addJS = function(editor, src, id, onReady) {

	try {
		var doc;

		if (editor) {
			doc = editor.document.$;
		}else {
			doc = document;
		}

		var scriptElement = doc.createElement('script');

		if (id) {
			scriptElement.id = id;
		}

		scriptElement.type = 'text/javascript';
		scriptElement.src = src;

		if (onReady) {
			scriptElement.onload = onReady;						//most browsers
			scriptElement.onreadystatechange = function() {		//ie
				if (this.readyState == 'complete') {
					onReady();
				}
			}
		}

		doc.head.appendChild(scriptElement);
	}catch (e) {

	}

};

CKEDITOR.SemwidgJS.addCSS = function(editor, href, id, onReady) {

	try {
		var doc;

		if (editor) {
			doc = editor.document.$;
		}else {
			doc = document;
		}

		var cssElement = doc.createElement('link');

		if (id) {
			cssElement.id = id;
		}

		cssElement.type = 'text/css';
		cssElement.rel = 'stylesheet';
		cssElement.href = href;

		if (onReady) {
			cssElement.onload = onReady;						//most browsers
			cssElement.onreadystatechange = function() {		//ie
				if (this.readyState == 'complete') {
					onReady();
				}
			}
		}

		doc.head.appendChild(cssElement);
	}catch (e) {
		console.error(e);
	}

};

CKEDITOR.SemwidgJS.changeElementType = function(element, newType) {

	var elem = $(element);

	var attrs = {};

	for (var i = 0; i < element.attributes.length; i++) {
		var a = element.attributes[i];
		attrs[a.nodeName] = a.nodeValue;
	}

	elem.replaceWith(function () {
		return $('<' + newType + ' />', attrs).append($(this).contents());
	});

};

CKEDITOR.SemwidgJS.delay = (function(){
	var timer = 0;
	return function(callback, ms){
		clearTimeout(timer);
		timer = setTimeout(callback, ms);
	};
})();

CKEDITOR.SemwidgJS.levenshteinDistance = function(a, b) {

	var a_length = a ? a.length : 0;
	var b_length = b ? b.length : 0;

	if(a_length == 0) {
		return b_length; 
	}

	if(b_length == 0) {
		return a_length; 
	}

	var matrix = [];

	// increment along the first column of each row
	var i;
	for(i = 0; i <= b_length; i++){
		matrix[i] = [i];
	}

	// increment each column in the first row
	var j;
	for(j = 0; j <= a_length; j++){
		matrix[0][j] = j;
	}

	// Fill in the rest of the matrix
	for(i = 1; i <= b_length; i++){
		for(j = 1; j <= a_length; j++){
			if(b.charAt(i-1) == a.charAt(j-1)){
				matrix[i][j] = matrix[i-1][j-1];
			} else {
				matrix[i][j] = Math.min(matrix[i-1][j-1] + 1, // substitution
				Math.min(matrix[i][j-1] + 1, // insertion
				matrix[i-1][j] + 1)); // deletion
			}
		}
	}

	return matrix[b_length][a_length];
};

CKEDITOR.SemwidgJS._autosuggestPrompt;
CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem = -1;
CKEDITOR.SemwidgJS.getAutosuggestPrompt = function() {
	if (!CKEDITOR.SemwidgJS._autosuggestPrompt) {
		var elem = $('<div class="semwidg-autosuggest-output"></div>');
		elem.appendTo('body');
		CKEDITOR.SemwidgJS._autosuggestPrompt = elem;
	}

	return CKEDITOR.SemwidgJS._autosuggestPrompt;
};

CKEDITOR.SemwidgJS.textInputToAutosuggest = function(elementOrId, hideOnEnter) {

	var element;

	if (typeof elementOrId === 'string' || elementOrId instanceof String) {
		element = $('#' + elementOrId)
	}else {
		element = elementOrId;
	}

	return CKEDITOR.SemwidgJS._textInputToAutosuggest(element, hideOnEnter);
	
};

CKEDITOR.SemwidgJS._textInputToAutosuggest = function(element, hideOnEnter) {

	var autosuggestObj = {};

	autosuggestObj['element'] = element;

	autosuggestObj['setRequestFunction'] = function(requestFunction, delay) {
		this.requestFunction = requestFunction;
		this.delay = delay;
	};

	autosuggestObj['setSelectFunction'] = function(selectFunction) {
		this.selectFunction = selectFunction;
	}

	autosuggestObj['setResult'] = function(result) {
		this.result = result;

		var prompt = CKEDITOR.SemwidgJS.getAutosuggestPrompt();
		prompt.empty();
		CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem = -1

		if (!result) {
			return;
		}

		for (var i = 0; i < result.length; i++) {
			var displayValue;
			var dataValue;

			if (result[i] instanceof Array) {
				if (result[i].length > 1) {
					displayValue = result[i][0];
					dataValue = result[i][1];
				}else {
					displayValue = '' + result[i];
					dataValue = '' + result[i];
				}
			}else {
				displayValue = '' + result[i];
				dataValue = '' + result[i];
			}

			var elem = $('<div data-sw-util-value="' + dataValue +'" class="semwidg-autosuggest-element">' + displayValue + '</div>');

			// elem.on('mouseover', function(e) {
			// 	$(this).css('background-color', '#E4E4E4');
			// });

			// elem.on('mouseout', function(e) {
			// 	$(this).css('background-color', '#FFFFFF');
			// });

			elem.on('mousedown', function(e) {
				if (autosuggestObj.selectFunction) {

					var value = $(this).attr('data-sw-util-value');
					autosuggestObj.selectFunction(value);
					
					autosuggestObj.element.focus();

					if (hideOnEnter) {
						prompt.css('visibility', 'hidden');
					}

					return false;
				}
			});

			prompt.append(elem);
		}
	};

	element.on('focus', function(e) {
		var prompt = CKEDITOR.SemwidgJS.getAutosuggestPrompt();

		element.after(prompt);
		
		prompt.empty();
		CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem = -1
		var input = element.val();

		if (input == '') {
			input = element.text();
		}

		if (autosuggestObj.requestFunction) {
			autosuggestObj.requestFunction(input);
		}

		prompt.css('visibility', 'visible');
		prompt.css('width', element.outerWidth() - 2);

	});

	element.on('click', function(e) {
		var prompt = CKEDITOR.SemwidgJS.getAutosuggestPrompt();

		element.after(prompt);
		
		prompt.empty();
		CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem = -1
		var input = element.val();

		if (input == '') {
			input = element.text();
		}

		if (autosuggestObj.requestFunction) {
			autosuggestObj.requestFunction(input);
		}

		prompt.css('visibility', 'visible');
		prompt.css('width', element.outerWidth() - 2);

	});

	element.on('blur', function(e) {
		var prompt = CKEDITOR.SemwidgJS.getAutosuggestPrompt();
		prompt.css('visibility', 'hidden');
	});

	element.on('keydown', function(e) {

		var prompt = CKEDITOR.SemwidgJS.getAutosuggestPrompt();
		var offset = element.offset();

		// prompt.css('top', offset.top + element.outerHeight());
		// prompt.css('left', offset.left);
		prompt.css('width', element.outerWidth() - 2);

		var keycode = e.keyCode;

		// arrow up or down
		if (keycode == 38 || keycode == 40) {
			e.preventDefault();

			var children = prompt.children();
			var length = children.length;

			// up
			if (keycode == 38) {
				if (CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem <= 0 && length > 0) {
					CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem = length - 1;
				}else {
					CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem = CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem - 1;
				}
			}

			// down
			if (keycode == 40) {
				if (CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem >= length - 1 && length > 0) {
					CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem = 0;
				}else {
					CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem = CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem + 1;
				}
			}

			for (var i = 0; i < length; i++) {
				if (i == CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem){
					$(children[i]).css('background-color', '#E4E4E4');
				}else {
					$(children[i]).css('background-color', '#FFFFFF');
				}
			}

			var item = children[CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem];
			var offset = item.getBoundingClientRect().y 
					- prompt[0].getBoundingClientRect().y
					+ prompt[0].scrollTop - 40;

			prompt[0].scrollTo(0, offset);

			return false;
		}

		// enter
		else if (keycode == 13) {
			
			if (prompt.css('visibility') !== 'hidden') {

				e.preventDefault();

				if (autosuggestObj.selectFunction) {
					var children = prompt.children();
					var length = children.length;

					if (CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem >= 0 &&
							CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem < length) {

						if (hideOnEnter) {
							prompt.css('visibility', 'hidden');
						}

						var value = $(children[CKEDITOR.SemwidgJS._autosuggestPromptSelectedItem]).attr('data-sw-util-value');
						autosuggestObj.selectFunction(value);
					}
					
				}

				return false;
			}
		}

		// escape
		else if (keycode == 27) {
			
			if (prompt.css('visibility') !== 'hidden') {
				e.preventDefault();
				prompt.css('visibility', 'hidden');
				return false;
			}
		}

		else {
			prompt.css('visibility', 'visible');
		}

	});

	element.on('keyup', function(e) {

		var keycode = e.keyCode;
		// not arrow up or down
		if (keycode != 38 && keycode != 40) {
			var input = element.val();

			if (input == '') {
				input = element.text();
			}

			if (autosuggestObj.requestFunction) {
				autosuggestObj.requestFunction(input);
			}
		}
	});

	element.on('paste', function(e) {
		e.preventDefault();
		var text = (e.originalEvent || e).clipboardData.getData('text/plain');
		document.execCommand('insertHTML', false, text);
	});

	return autosuggestObj;
	
};

CKEDITOR.SemwidgJS.getCursorPosition = function(inputElement) {

	if (!inputElement) {
		return -1;
	}

	// var cursorPosition = 0;

	// if (document.selection) {
	// 	inputElement.focus();
	// 	var selection = document.selection.createRange();
	// 	selection.moveStart('character', -inputElement.value.length);
	// 	cursorPosition = selection.text.length;
	// }else if (inputElement.selectionStart || inputElement.selectionStart == '0') {
	// 	cursorPosition = inputElement.selectionStart;
	// }

	// return cursorPosition;

	var doc = inputElement.ownerDocument || inputElement.document;
	var win = doc.defaultView || doc.parentWindow;
	var sel;
	var caretOffset;
	
	if (typeof win.getSelection != 'undefined') {
		sel = win.getSelection();
		if (sel.rangeCount > 0) {
			var range = win.getSelection().getRangeAt(0);
			var preCaretRange = range.cloneRange();
			preCaretRange.selectNodeContents(inputElement);
			preCaretRange.setEnd(range.endContainer, range.endOffset);
			caretOffset = preCaretRange.toString().length;
		}
	} else if ( (sel = doc.selection) && sel.type != 'Control') {
		var textRange = sel.createRange();
		var preCaretTextRange = doc.body.createTextRange();
		preCaretTextRange.moveToElementText(inputElement);
		preCaretTextRange.setEndPoint('EndToEnd', textRange);
		caretOffset = preCaretTextRange.text.length;
	}

	return caretOffset;
};

CKEDITOR.SemwidgJS.isDividingChar = function(character, previous) {

	if (!previous) {
		previous = '';
	}

	if (character == ' ' ||
		character == '.' && previous != '\\' ||
		character == '(' ||
		character == ')' ||
		character == '{' ||
		character == '}' ||
		character == '[' ||
		character == ']' ||
		character == '<' ||
		character == '>' ||
		character == '=' ||
		character == '!' ||
		character == '&' ||
		character == '|' ||
		character == '+' ||
		// character == '-' ||
		character == '*' ||
		character == '/') {
		return true;
	}

	return false;
};

CKEDITOR.SemwidgJS.AutoSuggest = function() {};

CKEDITOR.SemwidgJS.AutoSuggest.filterResult = function(result, filterValue) {

	if (!result) {
		return [];
	}

	result.sort(function(a, b) {

		var weight = 100;

		// similarity
		if (!a.levenshteinLabel) {
			a.levenshteinLabel = a.getLabelCI() ? CKEDITOR.SemwidgJS.levenshteinDistance(a.getLabelCI(), filterValue) : Infinity;
			
			if (a.getLabelCI() && a.getLabelCI().indexOf(filterValue) > -1) {
				a.levenshteinLabel = a.levenshteinLabel / weight;
			}
		}
		if(!a.levenshteinValue) {
			a.levenshteinValue = CKEDITOR.SemwidgJS.levenshteinDistance(a.getValueCI(), filterValue);
			if (a.getValueCI().indexOf(filterValue) > -1) {
				a.levenshteinValue = a.levenshteinValue / weight;
			}
		}

		if (!b.levenshteinLabel) {
			b.levenshteinLabel = b.getLabelCI() ? CKEDITOR.SemwidgJS.levenshteinDistance(b.getLabelCI(), filterValue) : Infinity;
			if (b.getLabelCI() && b.getLabelCI().indexOf(filterValue) > -1) {
				b.levenshteinLabel = b.levenshteinLabel / weight;
			}
		}
		if(!b.levenshteinValue) {
			b.levenshteinValue = CKEDITOR.SemwidgJS.levenshteinDistance(b.getValueCI(), filterValue);
			if (b.getValueCI().indexOf(filterValue) > -1) {
				b.levenshteinValue = b.levenshteinValue / weight;
			}
		}

		return Math.min(a.levenshteinLabel, a.levenshteinValue) - Math.min(b.levenshteinLabel, b.levenshteinValue);
	});

	return result;
};

CKEDITOR.SemwidgJS.AutoSuggest.ResultElement = function() {

};

CKEDITOR.SemwidgJS.AutoSuggest.ResultElement.prototype.getValue = function() {
	return this.value;
};

CKEDITOR.SemwidgJS.AutoSuggest.ResultElement.prototype.getValueCI = function() {
	if (!this.valueCI) {
		if (!this.value) {
			return '';
		}else {
			this.valueCI = this.value.toLowerCase();
		}
	}
	return this.valueCI;
};

CKEDITOR.SemwidgJS.AutoSuggest.ResultElement.prototype.setValue = function(value) {
	this.value = value;
	this.valueCI = null;
};

CKEDITOR.SemwidgJS.AutoSuggest.ResultElement.prototype.getLabel = function() {
	return this.label;
};

CKEDITOR.SemwidgJS.AutoSuggest.ResultElement.prototype.getLabelCI = function() {
	if (!this.labelCI) {
		if (!this.label) {
			return '';
		}else {
			this.labelCI = this.label.toLowerCase();
		}
	}
	return this.labelCI;

};

CKEDITOR.SemwidgJS.AutoSuggest.ResultElement.prototype.setLabel = function(label) {
	this.label = label;
	this.labelCI = null;
};

CKEDITOR.SemwidgJS.AutoSuggest.ResultElement.prototype.toHtml = function() {

	var str = '';

	str += '<div class="semwidg-autocomplete-result" style="white-space: nowrap;">';

		str += '<span class="semwidg-autocomplete-label">' + this.getLabel() + '</span>';
		str += ' ';
		str += '<span class="semwidg-autocomplete-uri">(<span style="font-family: monospace;">' + this.getValue() + '</span>)</span>';

	str += '</div>';

	return str;

};

CKEDITOR.SemwidgJS.getEditorById = function(editorId) {
	var editor;
	for (var e in CKEDITOR.instances) {
		CKEDITOR.instances[e];
		if (CKEDITOR.instances[e].id === editorId) {
			editor = CKEDITOR.instances[e];
			break;
		}
	}
	return editor;
};

CKEDITOR.SemwidgJS.refresh = function(editorId) {
	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);

	if (editor) {
		editor.setMode('source');
		editor.setMode('wysiwyg');
	}
}
	

CKEDITOR.SemwidgJS.deleteSemwidgElement = function(type, element, id, editorId) {

	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);

	var swElement = editor.getSemwidgJS().Util.getSemwidgElementById(id);
	if (!swElement) {
		return;
	}

	var widgetId = swElement._getNode().parentNode.getAttribute('data-cke-widget-id');
	var ckwidget = editor.widgets.instances[widgetId];

	var confirmation = confirm('Do you really want to delete this item?\n\n\t' + element + ': "' + id + '"');

	if (confirmation) {
		ckwidget.repository.del(ckwidget);
		editor.setMode('source');
		editor.setMode('wysiwyg');
	}
	
};

CKEDITOR.SemwidgJS.editSemwidgElement = function(type, element, id, editorId) {

	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);

	var swElement = editor.getSemwidgJS().Util.getSemwidgElementById(id);
	if (!swElement) {
		return;
	}

	var widgetId = swElement._getNode().parentNode.getAttribute('data-cke-widget-id');
	var ckwidget = editor.widgets.instances[widgetId];
	ckwidget.edit();
};

CKEDITOR.SemwidgJS.addSemwidgElement = function(type, element, editorId, data) {

	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);
	var value = '';

	if (element && element != '' && editor.widgets.selected.length > 0) {
		var range = editor.createRange();
		var e = CKEDITOR.dom.element.createFromHtml('<p>&nbsp;</p>');
		e.insertAfter(editor.getSelection().getSelectedElement());

		range.setStartAt(e, CKEDITOR.POSITION_AFTER_START);
		range.setEndAt(e, CKEDITOR.POSITION_BEFORE_END);
		editor.getSelection().selectRanges([range]);
	}

	if (type === 'Config') {
		if (element === 'Endpoint' || element === 'Resource' || 
			element === 'Namespace' || element === 'Mapping' || 
			element === 'Proxy') {

			CKEDITOR.SemwidgJS.data.configType = 'config_' + element;
			editor.widgets.registered['semwidgConfig'].template = new CKEDITOR.template(CKEDITOR.SemwidgJS.getTemplateForConfig(element, editor, data));
			editor.execCommand('semwidgConfig');
		}

	}else if (type === 'Widget') {
		var allWidgetTypes = editor.getSemwidgJS().WidgetProvider.getWidgetTypes();
		var isWidget = false;

		for (var widgetType in allWidgetTypes) {
			if (element == widgetType) {
				isWidget = true;
				break;
			}
		}

		if (isWidget) {
			CKEDITOR.SemwidgJS.data.widgetType = 'widget_' + element;
			editor.widgets.registered['semwidgWidget'].template = new CKEDITOR.template(CKEDITOR.SemwidgJS.getTemplateForWidget(element, editor, data));
			editor.execCommand('semwidgWidget');
		}

	}else if (type === 'Template') {
		var definitions = editor.getSemwidgJS().getTemplateProvider().getTemplateDefinitions();
		var isDefinition = false;

		for (var i = 0; i < definitions.length; i++) {
			if (element == definitions[i].getId()) {
				isDefinition = true;
				break;
			}
		}

		if (isDefinition) {
			CKEDITOR.SemwidgJS.data.templateType = 'template_' + element;
			editor.widgets.registered['semwidgTemplateInstance'].template = new CKEDITOR.template(CKEDITOR.SemwidgJS.getTemplateForTemplate(element, editor, data));
			editor.execCommand('semwidgTemplateInstance');
		}
	}

};

CKEDITOR.SemwidgJS.createTemplate = function(editorId) {
	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);

	var selection = editor.getSelectedHtml(true);

	var id = 'Template-' + editor.getSemwidgJS().Util.getUniqueId();
	editor.insertHtml('<div data-sw-config="template" data-swp-id="' + id + '" data-swp-parameter="value">' + selection + '</div>');


	var templateNode = $(editor.document.$).find('*[data-swp-id="' + id + '"]');

	CKEDITOR.SemwidgJS.newElementIds.push(id);

	var i = 0;

	var widgets = templateNode.find('*[data-sw-widget]');
	var configs = templateNode.find('*[data-sw-config]').not('*[data-sw-config="template"]');
	var templates = templateNode.find('*[data-sw-template]');

	for (i = 0; i < widgets.length; i++) {
		while (widgets[i].lastChild) {
			widgets[i].removeChild(widgets[i].lastChild);
		}
	}

	for (i = 0; i < configs.length; i++) {
		while (configs[i].lastChild) {
			configs[i].removeChild(configs[i].lastChild);
		}
	}

	for (i = 0; i < templates.length; i++) {
		while (templates[i].lastChild) {
			templates[i].removeChild(templates[i].lastChild);
		}
	}

	editor.setMode('source');
	editor.setMode('wysiwyg');

	var func = (function() {
		CKEDITOR.SemwidgJS.editSemwidgElement('TemplateDefinition', 'TemplateDefinition', id, editorId);
	});
	CKEDITOR.SemwidgJS.runAfterSemwidgIsLoaded.push(func);

	// var func2 = (function() {
	// 	CKEDITOR.SemwidgJS.setPosition(editor);
	// });
	// CKEDITOR.SemwidgJS.runAfterSemwidgIsLoaded.push(func2);
}

// ~~ Based on: http://www.gnostice.com/nl_article.asp?id=208&t=making_an_interactive_treeview_control_from_an_html_nested_list
// This function traverses the list and add links 
// to nested list items
CKEDITOR.SemwidgJS.activateTree = function(oList) {
	// Collapse the tree
	oList.classList.add('collapsed');
	var uls = oList.getElementsByTagName('ul');
	var elem;
	for (var i=0; i < uls.length; i++) {
		elem = uls[i];
		elem.style.display = 'none';
	}
	// Add the click-event handler to the list items
	if (oList.addEventListener) {
		oList.addEventListener('click', CKEDITOR.SemwidgJS.toggleBranch, false);
	} else if (oList.attachEvent) { // For IE
		oList.attachEvent('onclick', CKEDITOR.SemwidgJS.toggleBranch);
	}
	// Make the nested items look like links
	CKEDITOR.SemwidgJS.addLinksToBranches(oList);
};

// This is the click-event handler
CKEDITOR.SemwidgJS.toggleBranch = function(event) {
	var oBranch, cSubBranches;
	if (event.target) {
		oBranch = event.target;
	} else if (event.srcElement) { // For IE
		oBranch = event.srcElement;
	}
	cSubBranches = oBranch.getElementsByTagName('ul');

	if (cSubBranches[0] && cSubBranches[0].getElementsByTagName('li').length > 0) {
		oBranch.parentNode.classList.toggle('collapsed');
		oBranch.parentNode.classList.toggle('expanded');
	} else {
		oBranch.parentNode.classList.add('empty');
	}

	for (var i = 0; i < cSubBranches.length > 0; i++) {
		if (cSubBranches[i].parentNode === oBranch) {
			if (cSubBranches[i].style.display == 'block') {
				cSubBranches[i].style.display = 'none';
			} else {
				cSubBranches[i].style.display = 'block';
			}
		}
	}
};

// This function makes nested list items look like links
CKEDITOR.SemwidgJS.addLinksToBranches = function(oList) {
	var cBranches = oList.getElementsByTagName('li');
	var i, j, n, cSubBranches;

	if (cBranches.length > 0) {
		for (i = 0, n = cBranches.length; i < n; i++) {

			cSubBranches = cBranches[i].getElementsByTagName('ul');

			if (cSubBranches.length > 0) {
				cBranches[i].className = 'branch';

				if (cBranches[i].getElementsByTagName('li').length > 0) {
					cBranches[i].parentNode.classList.add('collapsed');
					for (j = 0; j < cSubBranches.length; j++) {
						CKEDITOR.SemwidgJS.addLinksToBranches(cSubBranches[j]);
						cSubBranches[j].className = 'subBranch';
					}
				} else {
					cBranches[i].parentNode.classList.add('empty');
				}

				
			}
		}
	}
};

CKEDITOR.SemwidgJS.toggleHighlightWidgets = function(checkbox, editorId) {

	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);
	var stylesheet = CKEDITOR.SemwidgJS.getStyleSheetById('_SemwidgStyles_', editorId);
	
	var rules = stylesheet.cssRules || stylesheet.rules;
	var rule = CKEDITOR.SemwidgJS.getCssRuleBySelector(rules, '[data-widget="semwidgWidget"]');
	var rule2 = CKEDITOR.SemwidgJS.getCssRuleBySelector(rules, '[data-widget="semwidgConfig"]');
	var rule3 = CKEDITOR.SemwidgJS.getCssRuleBySelector(rules, '[data-widget="semwidgTemplate"]');
	var rule4 = CKEDITOR.SemwidgJS.getCssRuleBySelector(rules, '[data-widget="semwidgTemplateInstance"]');

	if (checkbox.checked) {
		rule.style['border-style'] = 'solid';
		rule2.style['border-style'] = 'solid';
		rule3.style['border-style'] = 'solid';
		rule4.style['border-style'] = 'solid';
		rule4.style['background'] = 'repeating-linear-gradient(135deg, #f0f0f0,	#f0f0f0 10px, #f8f8f8 10px, #f8f8f8 20px)';
	}else {
		rule.style['border-style'] = 'none';
		rule2.style['border-style'] = 'none';
		rule3.style['border-style'] = 'none';
		rule4.style['border-style'] = 'none';
		rule4.style['background'] = 'transparent';
	}
};

CKEDITOR.SemwidgJS.toggleConfigVisibility = function(checkbox, editorId) {

	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);
	var stylesheet = CKEDITOR.SemwidgJS.getStyleSheetById('_SemwidgStyles_', editorId);
	var rules = stylesheet.cssRules || stylesheet.rules;
	var rule = CKEDITOR.SemwidgJS.getCssRuleBySelector(rules, '[data-widget="semwidgConfig"]');

	if (checkbox.checked) {
		rule.style.display = '';
	}else {
		rule.style.display = 'none';
	}
};

CKEDITOR.SemwidgJS.toggleTemplateDefinitionVisibility = function(checkbox, editorId) {

	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);
	var stylesheet = CKEDITOR.SemwidgJS.getStyleSheetById('_SemwidgStyles_', editorId);
	var rules = stylesheet.cssRules || stylesheet.rules;
	var rule = CKEDITOR.SemwidgJS.getCssRuleBySelector(rules, '[data-sw-config="template"]');

	if (checkbox.checked) {
		rule.style.setProperty('display', 'block', 'important');
	}else {
		rule.style.display = 'none';
	}
};

CKEDITOR.SemwidgJS.getStyleSheetById = function(id, editorId) {

	var doc;
	if (editorId)  {
		var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);
		doc = editor.document.$;
	}else {
		doc = document;
	}

	var stylesheets = doc.styleSheets;
	var i = 0;
	var idObj = null;
	for (i = 0; i < stylesheets.length; i++) {
		idObj = stylesheets[i].ownerNode.attributes.id;
		if (idObj && idObj.nodeValue === id) {
			return stylesheets[i];
		}
	}
};

CKEDITOR.SemwidgJS.getCssRuleBySelector = function(cssRule, selector) {

	if (!cssRule) {
		return;
	}

	var i = 0;
	var ruleObj = null;
	for (i = 0; i < cssRule.length; i++) {
		if (cssRule[i].selectorText == selector) {
			return cssRule[i];
		}
	}

};

CKEDITOR.SemwidgJS.SemwidgToolsModel = function() {

	this.highlightWidgetsState = true;
	this.showConfigWidgetsState = true;
	this.showConfigTemplateDefinitionState = true;
	this.collapsibleListConfig = null;
	this.collapsibleListWidgets = null;
	this.collapsibleListTemplates = null;

};

CKEDITOR.SemwidgJS.CollapsibleListItem = function() {
	this.label;
	this.collapsed = true;
	this.children = [];
};

CKEDITOR.SemwidgJS.recreateSemwidgToolsState = function(editor) {

	var model = editor.semwidgToolsModel;
	var doc = editor.document.$;
	var semwidgTools = document.getElementById(editor.id + '_semwidgTools');

	if (model.highlightWidgetsState) {
		document.getElementById(editor.id + '_semwidgTools_toggleWidgetHighlight').checked = true;
	}else {
		document.getElementById(editor.id + '_semwidgTools_toggleWidgetHighlight').checked = false;
	}
	CKEDITOR.SemwidgJS.toggleHighlightWidgets(document.getElementById(editor.id + '_semwidgTools_toggleWidgetHighlight'), editor.id);


	if (model.showConfigWidgetsState) {
		document.getElementById(editor.id + '_semwidgTools_toggleConfigVisibility').checked = true;
	}else {
		document.getElementById(editor.id + '_semwidgTools_toggleConfigVisibility').checked = false;
	}
	CKEDITOR.SemwidgJS.toggleConfigVisibility(document.getElementById(editor.id + '_semwidgTools_toggleConfigVisibility'), editor.id);

	if (model.showConfigTemplateDefinitionState) {
		document.getElementById(editor.id + '_semwidgTools_toggleTemplateDefinitionVisibility').checked = true;
	}else {
		document.getElementById(editor.id + '_semwidgTools_toggleTemplateDefinitionVisibility').checked = false;
	}
	CKEDITOR.SemwidgJS.toggleTemplateDefinitionVisibility(document.getElementById(editor.id + '_semwidgTools_toggleTemplateDefinitionVisibility'), editor.id);

	var walkTree = function(node, listItem) {
		if (!node || !listItem) {
			return;
		}

		if (node.childNodes[0] && node.childNodes[0].classList.contains('branch')) {
			if (node.childNodes[0].childNodes[0].nodeValue !== listItem.label) {
				return;
			}
			
			if (listItem.collapsed === true) {
				node.classList.add('collapsed');
				node.classList.remove('expanded');
			}else if (listItem.collapsed === false) {
				node.classList.add('expanded');
				node.classList.remove('collapsed');

				var cSubBranches = node.getElementsByTagName('ul');
				for (var i = 0; i < cSubBranches.length > 0; i++) {
					if (cSubBranches[i].parentNode.parentNode === node) {
						if (cSubBranches[i].style.display == 'block') {
							cSubBranches[i].style.display = 'none';
						} else {
							cSubBranches[i].style.display = 'block';
						}

						for (var j = 0; j < listItem.children.length; j++) {
							walkTree(cSubBranches[i], listItem.children[j]);
						}
					}
				}
			}
		}
	};

	var configListItem = editor.semwidgToolsModel.collapsibleListConfig;
	var configListNode = document.getElementById(editor.id + '_semwidgTools_collapsibleListConfig');
	walkTree(configListNode, configListItem);

	var widgetListItem = editor.semwidgToolsModel.collapsibleListWidgets;
	var widgetListNode = document.getElementById(editor.id + '_semwidgTools_collapsibleListWidgets');
	walkTree(widgetListNode, widgetListItem);

	var templateListItem = editor.semwidgToolsModel.collapsibleListTemplates;
	var templateListNode = document.getElementById(editor.id + '_semwidgTools_collapsibleListTemplates');
	walkTree(templateListNode, templateListItem);

};

CKEDITOR.SemwidgJS.saveSemwidgToolsState = function(editor) {

	var highlightWidgetsCheckbox = document.getElementById(editor.id + '_semwidgTools_toggleWidgetHighlight');
	if (highlightWidgetsCheckbox.checked) {
		editor.semwidgToolsModel.highlightWidgetsState = true;
	}else {
		editor.semwidgToolsModel.highlightWidgetsState = false;
	}

	var showConfigWidgetsCheckbox = document.getElementById(editor.id + '_semwidgTools_toggleConfigVisibility');
	if (showConfigWidgetsCheckbox.checked) {
		editor.semwidgToolsModel.showConfigWidgetsState = true;
	}else {
		editor.semwidgToolsModel.showConfigWidgetsState = false;
	}

	var showConfigTemplateDefinitionCheckbox = document.getElementById(editor.id + '_semwidgTools_toggleTemplateDefinitionVisibility');
	if (showConfigTemplateDefinitionCheckbox.checked) {
		editor.semwidgToolsModel.showConfigTemplateDefinitionState = true;
	}else {
		editor.semwidgToolsModel.showConfigTemplateDefinitionState = false;
	}

	var walkTree = function(node, listItem) {
		if (!node || !listItem) {
			return;
		}

		if (node.classList.contains('collapsed')) {
			listItem.collapsed = true;
		}else {
			listItem.collapsed = false;
		}

		if (node.childNodes[0] && node.childNodes[0].classList.contains('branch')) {
			listItem.label = node.childNodes[0].childNodes[0].nodeValue;

			for (var i = 0; i < node.childNodes[0].childNodes.length; i++) {
				
				if (node.childNodes[0].childNodes[i].nodeName == 'UL' 
						&& node.childNodes[0].childNodes[i].classList.contains('subBranch')) {
					var childListItem = new CKEDITOR.SemwidgJS.CollapsibleListItem();
					listItem.children.push(childListItem);
					walkTree(node.childNodes[0].childNodes[i], childListItem);
				}
			}
		}
	};

	var configListItem = new CKEDITOR.SemwidgJS.CollapsibleListItem();
	var configListNode = document.getElementById(editor.id + '_semwidgTools_collapsibleListConfig');
	walkTree(configListNode, configListItem);
	editor.semwidgToolsModel.collapsibleListConfig = configListItem;

	var widgetListItem = new CKEDITOR.SemwidgJS.CollapsibleListItem();
	var widgetListNode = document.getElementById(editor.id + '_semwidgTools_collapsibleListWidgets');
	walkTree(widgetListNode, widgetListItem);
	editor.semwidgToolsModel.collapsibleListWidgets = widgetListItem;

	var templateListItem = new CKEDITOR.SemwidgJS.CollapsibleListItem();
	var templateListNode = document.getElementById(editor.id + '_semwidgTools_collapsibleListTemplates');
	walkTree(templateListNode, templateListItem);
	editor.semwidgToolsModel.collapsibleListTemplates = templateListItem;

};

CKEDITOR.SemwidgJS.execCommand = function(editorId, command) {

	var editor = CKEDITOR.SemwidgJS.getEditorById(editorId);
	if (editor && command) {
		editor.execCommand(command);
	}
};

CKEDITOR.SemwidgJS.createNewWidgetFromResource = function(editor) {
	var widget = editor.widgets.selected[0];
	var data = {value: '&#123;' + widget.element.getAttribute('data-swp-id') + '&#125;'};
	CKEDITOR.SemwidgJS.addSemwidgElement('Widget', 'SwText', editor.id, data)
};

CKEDITOR.SemwidgJS.autosuggestPropertyQueryToSparql = function(query, editor) {
	var SemwidgJS = editor.getSemwidgJS();
	var SemwidgQL = editor.getSemwidgQL();

	var aggregate = false;
	var sparql;

	try {
		sparql = SemwidgJS.Util.SemwidgQL.toSparql(query, null, true);
	}catch (e) {
		return null;
	}
	
	var lines = sparql[0].split(/\r?\n/);

	var wsReg = /\s/;

	var lang = 'en'; //TODO: get language from endpoint

	var i, j = 0;

	var prefixes;
	var where;
	for (i = 0; i < lines.length; i++) {
		if (lines[i].indexOf('WHERE {') > -1) {
			prefixes = lines.slice(0, i - 1);
			where = lines.slice(i + 1, lines.length - 1);
			break;
		}
	}

	//remove BIND, GROUP and ORDER lines
	var tempWhere = [];
	for (i = 0; i < where.length; i++) {
		if (!where[i].trim().indexOf('BIND') == 0 &&
				!where[i].trim().indexOf('GROUP') == 0 &&
				!where[i].trim().indexOf('BIND') == 0) {
			tempWhere.push(where[i]);
		}
	}
	where = tempWhere;

	var swInternalPropertyIndex = [];
	for (i = 0; i < where.length; i++) {
		if (where[i].indexOf('swInternal:swInternalProperty') > -1) {
			swInternalPropertyIndex.push(i);
		}
	}

	var q = '';

	q += prefixes.join('\n') + '\n';
	q += 'SELECT DISTINCT ?property ?propertyOf ?label ?value \n';
	q += 'WHERE {\n';

	q += '\t{ \n';

	var isSwInternalProperty = false;
	
	var object;
	var q1 = '';
	for (i = 0; i < where.length; i++) {

		for (j = 0; j < swInternalPropertyIndex.length; j++) {

			isSwInternalProperty = false;
			if (i == swInternalPropertyIndex[j]) {
				isSwInternalProperty = true;
				break;
			}
		}

		if (isSwInternalProperty) {

			var startIndexLeft;
			var endIndexLeft = where[i].indexOf('swInternal:swInternalProperty') - 2;
			for (startIndexLeft = endIndexLeft; startIndexLeft >= 0; startIndexLeft--) {
				if (wsReg.test(where[i][startIndexLeft])) {
					startIndexLeft++;
					endIndexLeft++;
					break;
				}
			}

			var startIndexRight = endIndexLeft + 31;
			var endIndexRight;
			for (endIndexRight = startIndexRight; endIndexRight < where[i].length; endIndexRight++) {
				if (wsReg.test(where[i][endIndexRight])) {
					break;
				}
			}

			object = where[i].substring(startIndexRight, endIndexRight);

			q1 += '\t\t' + where[i].replace('swInternal:swInternalProperty', '?property') + '\n';

			// q1 += '\t\t\tFILTER (!isLiteral(' + object + ') || lang(' + object + ') = \'\' || langMatches(lang(' + object + '), \'' + lang + '\')) . \n';
			q1 += '\t\t\tOPTIONAL { ?property <http://www.w3.org/2000/01/rdf-schema#label> ?label . } \n';

		}else {
			if (!object || !(where[i].indexOf(object) >= 0 && where[i].indexOf('FILTER') >= 0)) {
				q1 += '\t' + where[i] + '\n';
			}
		}
	}

	// aggregate = q1.indexOf('GROUP BY') > -1;

	// if (aggregate) {
	// 	q += '\tSELECT SAMPLE(?property) SAMPLE(?label) (STR(MIN(' + object + ')) AS ?valO) WHERE { \n';
	// }else {
		q += '\tSELECT ?property ?label (STR(MIN(' + object + ')) AS ?valO) WHERE { \n';
	// }
	
	q += q1;
	
	q += '\t} \n';
	q += '\tUNION \n';
	q += '\t{ \n'; 
	

	var subject;
	var q2 = '';
	for (i = 0; i < where.length; i++) {

		isSwInternalProperty = false;
		for (j = 0; j < swInternalPropertyIndex.length; j++) {
			if (i == swInternalPropertyIndex[j]) {
				isSwInternalProperty = true;
				break;
			}
		}

		if (isSwInternalProperty) {

			var startIndexLeft;
			var endIndexLeft = where[i].indexOf('swInternal:swInternalProperty') - 2;
			for (startIndexLeft = endIndexLeft; startIndexLeft >= 0; startIndexLeft--) {
				if (wsReg.test(where[i][startIndexLeft])) {
					startIndexLeft++;
					endIndexLeft++;
					break;
				}
			}

			var startIndexRight = endIndexLeft + 31;
			var endIndexRight;
			for (endIndexRight = startIndexRight; endIndexRight < where[i].length; endIndexRight++) {
				if (wsReg.test(where[i][endIndexRight])) {
					break;
				}
			}

			subject = where[i].substring(startIndexRight, endIndexRight);

			q2 += '\t\t' + where[i].substring(0, startIndexLeft);
			q2 += subject;
			q2 += ' ?propertyOf ';
			q2 += where[i].substring(startIndexLeft, endIndexLeft);
			q2 += where[i].substring(endIndexRight, where[i].length + 1);
			q2 += '\n';

			// q2 += '\t\t\tFILTER (!isLiteral(' + subject + ') || lang(' + subject + ') = \'\' || langMatches(lang(' + subject + '), \'' + lang + '\')) . \n';
			q2 += '\t\t\tOPTIONAL { ?propertyOf <http://www.w3.org/2000/01/rdf-schema#label> ?label . } \n';


		}else {
			if (!subject || !(where[i].indexOf(subject) >= 0 && where[i].indexOf('FILTER') >= 0)) {
				q2 += '\t' + where[i] + '\n';
			}
		}
	}

	// aggregate = q2.indexOf('GROUP BY') > -1;

	// if (aggregate) {
	// 	q += '\tSELECT SAMPLE(?propertyOf) SAMPLE(?label) (STR(MIN(' + subject + ')) AS ?valS) WHERE { \n';
	// }else {
		q += '\tSELECT ?propertyOf ?label (STR(MIN(' + subject + ')) AS ?valS) WHERE { \n';
	// }

	q += q2;

	q += '\t} \n';
	q += '\tFILTER (lang(?label) = \'\' || langMatches(lang(?label), \'' + lang + '\')) . \n';
	q += '\tBIND ( CONCAT (?valO , ?valS) AS ?value) . \n';

	q += '}';

	// console.log(q);

	return q;
};

CKEDITOR.SemwidgJS.sanitizeHtml = function(value) {
	if (!value) {
		return '';
	}
	var output = value.replace(/<script[^>]*?>.*?<\/script>/gi, '').
				 replace(/<style[^>]*?>.*?<\/style>/gi, '').
				 replace(/<![\s\S]*?--[ \t\n\r]*>/gi, '');
	return output;
};

CKEDITOR.SemwidgJS.setPosition = function(editor) {

	// Add newline below last added element
	var lastElement;

	for (var i = CKEDITOR.SemwidgJS.newElementIds.length - 1; i >= 0; i--) {
		lastElement = editor.document.find('[data-swp-id="' + CKEDITOR.SemwidgJS.newElementIds[i] + '"]');
		if (lastElement.$.length > 0) {
			break;
		}
	}
	
	if (!lastElement || lastElement.$.length == 0) {
		return;
	}

	var parent = $($(lastElement.$[0])[0].parentElement);

	var nextElement = $(lastElement.$[0])[0].parentElement.nextElementSibling;
	
	if (!nextElement || nextElement.nodeName !== 'P') {
		// create new paragraph to select
		parent.after('<p>&nbsp;</p>');
	}

	nextElement = parent[0].nextElementSibling;

	// select newline element or next editable sibling element
	editor.focus();
	try {
		var range = editor.createRange();
		var element = new CKEDITOR.dom.element(nextElement);
		range.moveToElementEditablePosition( element, 1 );
		range.select();
		editor.insertText('');
	} catch (e) {}

};